#ifndef ARCHIVIO_TESI_H_
#define ARCHIVIO_TESI_H_

#include "AbstractTest.h"
#include "Tesi.h"
#include <cstdlib>
#include <iostream>
#include<string>
#include <vector>
using namespace std;

/* sostituire MATRICOLA con il proprio NumeroDiMatricola
 * ovunque, anche nel nome del file */
class ArchivioTesi12345 : public AbstractTest
{
	private:
		vector<Tesi> archivio;

	public:
		/* - - - - METODI DA IMPLEMENTARE - - - - */



		/* Se la tesi t non e' presente nell'archivio
		 * la inserisce alla fine dell'archivio e ritorna true.
		 * Altrimenti ritorna semplicemente false.
		 * senza inserirla. */
		virtual bool caricaTesi(Tesi t);


		/* Restituisce true se nell'archivio e' presente un autore
		 * il quale sia anche stato almeno una volta relatore.
		 * Altrimenti restituisce false. */
		virtual bool esisteAutoreRelatore() const;


		/* Restituisce il numero di relatori presenti nell'archivio */
		virtual int numeroRelatori() const;


		/* Restituisce il numero di tesi
		 * curate in media da un relatore.
		 * Se l'archivio e' vuoto restituisce 0 */
		virtual int dammiMediaTesiPerRelatore() const;


		/* Restituisce l'anno in cui si sono scritte piu' tesi.
		 * Nel caso vi siano piu' anni aventi tale caratteristica
		 * viene restituito l'anno piu' recente.
		 * Se l'archivio e' vuoto viene restituito 1900 */
		virtual int dammiAnnoMigliorePiuRecente() const;



		/* - - - - METODI DA NON MODIFICARE - - - - */
		ArchivioTesi12345(); //costruttore di default: crea un meteo vuoto
		virtual ~ArchivioTesi12345() {}
		vector<Tesi>& getContent();
};

#endif ARCHIVIO_TESI_H_